#define SHADOW_DISTORTION 0.85
#define SHADOW_STRENGTH 0.2 // [0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0]
#define SHADOW_SAMPLES 8 // [1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16]
#define SHADOW_SOFTNESS 2.0 // [0.0 1.0 2.0 3.0 4.0 5.0 6.0 7.0 8.0]
#define TRANSPARENT_SHADOWS 2 // [0 1 2]
#define FOLIAGE_SHADOW
const int shadowMapResolution = 2048; // [128 256 512 1024 2048 4096 8192]
const float sunPathRotation = -40.0; // [-90.0 -85.0 -80.0 -75.0 -70.0 -65.0 -60.0 -55.0 -50.0 -45.0 -40.0 -35.0 -30.0 -25.0 -20.0 -15.0 -10.0 -5.0 0.0 5.0 10.0 15.0 20.0 25.0 30.0 35.0 40.0 45.0 50.0 55.0 60.0 65.0 70.0 75.0 80.0 85.0 90.0]
const float shadowDistance = 160.0; // [16.0 32.0 48.0 64.0 80.0 96.0 112.0 128.0 144.0 160.0 176.0 192.0 208.0 224.0 240.0 256.0 272.0 288.0 304.0 320.0 336.0 352.0 368.0 384.0 400.0 416.0 432.0 448.0 464.0 480.0 496.0 512.0]
const float shadowDistanceRenderMul = 1.0;

const bool shadowHardwareFiltering = true;

#define FXAA
#ifdef FXAA
#endif


float cubeLength(vec2 v) {
    vec2 t = abs(v * v * v);
    return pow(t.x + t.y, 1.0/3.0);
}

vec3 getShadowBias(vec3 shadowClipPos, vec3 worldNormal, float faceNoL){
	float biasAdjust = log2(max(4.0, shadowDistance - shadowMapResolution * 0.125)) * 0.5;

	float factor = cubeLength(shadowClipPos.xy) * SHADOW_DISTORTION + (1.0 - SHADOW_DISTORTION);

	return mat3(shadowProjection) * (mat3(shadowModelView) * worldNormal) * factor * biasAdjust;
}

vec3 distort(vec3 pos) {
	float factor = cubeLength(pos.xy) * SHADOW_DISTORTION + (1.0 - SHADOW_DISTORTION);
	pos.xy /= factor;
	pos.z /= 2.0;
	// pos.xy += jitter[frameCounter % 16] * rcp(shadowMapResolution);
	return pos;
}

